﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace MyWebSite.Business
{
    public class User
    {
        /// <summary>
        /// User ID
        /// </summary>
        public int UserID { get; set; }

        /// <summary>
        /// Name
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Surname
        /// </summary>
        public string Surname { get; set; }

        /// <summary>
        /// User Type
        /// </summary>
        public UserType Type { get; set; }

        /// <summary>
        /// Indirizzo email
        /// </summary>
        public string Email  { get; set; }


        /// <summary>
        /// Carica i dati di un utente dal database
        /// </summary>
        public bool LoadFromDB(string username)
        {
            DataRow dr = Data.User.GetUserDataRow(username);
            if (dr != null)
            {
                //Legge i dati dal datarow
                this.UserID = Convert.ToInt32(dr["UserID"]);
                this.Name = dr["Name"].ToString();
                this.Surname = dr["Surname"].ToString();
                this.Type = (UserType)dr["UserTypeID"];
                this.Email = dr["Email"].ToString();

                return true;
            }

            return false;
        }

        /// <summary>
        /// Carica i dati di un utente
        /// </summary>
        public static User GetUser(string username)   
        {
            //Carica i dati da db
            Business.User objUser = new Business.User();
            if (objUser.LoadFromDB(username))
                return objUser;
            else
                return null;
        }

        

        /// <summary>
        /// Validazione dei dati di login di un utente
        /// </summary>
        /// <returns></returns>
        public static bool ValidateLogin(string username, string password)
        {
            return (Data.User.ValidateLogin(username, password) != -1);
        }
    }
}
