﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace MyWebSite.Data
{
    class DataHelper
    {
        public const string ConnectionStringName = "MyWebSiteConnection";

        /// <summary>
        /// Stringa di connessione al db
        /// </summary>
        public static string ConnectionString
        {
            get
            {
                return ConfigurationManager.ConnectionStrings[ConnectionStringName].ConnectionString;
            }
        }

        /// <summary>
        /// Esegue un command che ritorna una datatable
        /// </summary>
        public static DataTable ExecuteDataTable(SqlCommand cmd)
        {
            //Connsessione al db
            using (SqlConnection conn = new SqlConnection(ConnectionString))
            {
                cmd.Connection = conn;

                //DataAdapter per caricare i dati
                using (SqlDataAdapter da = new SqlDataAdapter(cmd))
                { 
                    conn.Open();

                    //Carica i dati in una datatable
                    DataTable dtReturn = new DataTable();
                    da.Fill(dtReturn);

                    return dtReturn;
                }
            }
        }

        /// <summary>
        /// ExecuteScalar di un command
        /// </summary>
        public static object ExecuteScalar(SqlCommand cmd)
        {
            using (SqlConnection conn = new SqlConnection(ConnectionString))
            {
                cmd.Connection = conn;

                //Apre la connessione
                conn.Open();

                return cmd.ExecuteScalar();
            }
        }

        /// <summary>
        /// ExecuteNonQuery di un command
        /// </summary>
        public static void ExecuteNonQuery(SqlCommand cmd)
        {
            using (SqlConnection conn = new SqlConnection(ConnectionString))
            {
                cmd.Connection = conn;

                //Apre la connessione
                conn.Open();

                cmd.ExecuteNonQuery();
            }
        }
    }
}
