﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace MyWebSite.Data
{
    public class User
    {
        /// <summary>
        /// Ritorna i dati di un utente
        /// </summary>
        public static DataRow GetUserDataRow(string username)
        {
            using (SqlCommand cmd = new SqlCommand("Common.proc_Users_Find"))
            {
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.AddWithValue("@username", username);

                using (DataTable dt = DataHelper.ExecuteDataTable(cmd))
                {
                    //Verifica esistenza dei dati
                    if (dt.Rows.Count > 0)
                        return dt.Rows[0];
                    else
                        return null;
                }
            }
        }

        /// <summary>
        /// Validazione dei dati di login di un utente
        /// </summary>
        /// <returns>
        /// ID dell'utente. -1 se la validazione è fallita
        /// </returns>
        public static int ValidateLogin(string username, string password)
        {
            using (SqlCommand cmd = new SqlCommand("Common.proc_Users_ValidateLogin"))
            {
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.AddWithValue("@username", username);
                cmd.Parameters.AddWithValue("@password", password);

                object obj = DataHelper.ExecuteScalar(cmd);

                if (obj != null && obj != DBNull.Value)
                    return Convert.ToInt32(obj);
                else
                    return -1;
            }
        }
    }
}
