﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Configuration.Provider;

namespace MyWebSite.Providers
{
    public class MyProfileProvider : System.Web.Profile.ProfileProvider
    {
        public override SettingsPropertyValueCollection GetPropertyValues(SettingsContext context, SettingsPropertyCollection collection)
        {
            //Crea la collection con i valori da ritornare
            SettingsPropertyValueCollection settings = new SettingsPropertyValueCollection();
            if (collection.Count == 0)
                return settings;

            //Popola la collection
            foreach (SettingsProperty prop in collection)
            {
                settings.Add(new SettingsPropertyValue(prop));
            }

            //Preleva lo username dal context
            string username = Convert.ToString(context["UserName"]);
            if (!string.IsNullOrEmpty(username))
            {
                //Carica istanza dell'oggetto utente
                Business.User objUser = UserLoader.GetUserObject(username);

                if (objUser != null)
                {
                    //Riferimento al tipo di classe dell'oggetto user
                    Type objType = objUser.GetType();

                    //Cicla l'elenco delle proprietà da valorizzare
                    foreach (SettingsPropertyValue prop in settings)
                    {
                        //Ricerca la property all'interno dell'oggetto Type
                        System.Reflection.PropertyInfo propInfo = objType.GetProperty(prop.Name);

                        //Verifica esistenza della property
                        if (propInfo == null)
                            throw new ProviderException(String.Format("Impossibile trovare la proprietà '{0}' specificata nel profilo", prop.Name));

                        //Preleva il valore della property dall'istanza della classe
                        prop.PropertyValue = propInfo.GetValue(objUser, null);
                    }
                }
                else
                    throw new ProviderException(String.Format("Impossibile caricare i dati dell'utente '{0}'", username));
            }

            return settings;

        }

        public override void SetPropertyValues(SettingsContext context, SettingsPropertyValueCollection collection)
        {
            //La fase di salvataggio delle proprietà non è implementata
            //throw new NotImplementedException();
        }

        public override int DeleteInactiveProfiles(System.Web.Profile.ProfileAuthenticationOption authenticationOption, DateTime userInactiveSinceDate)
        {
            throw new NotImplementedException();
        }

        public override int DeleteProfiles(string[] usernames)
        {
            throw new NotImplementedException();
        }

        public override int DeleteProfiles(System.Web.Profile.ProfileInfoCollection profiles)
        {
            throw new NotImplementedException();
        }

        public override System.Web.Profile.ProfileInfoCollection FindInactiveProfilesByUserName(System.Web.Profile.ProfileAuthenticationOption authenticationOption, string usernameToMatch, DateTime userInactiveSinceDate, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override System.Web.Profile.ProfileInfoCollection FindProfilesByUserName(System.Web.Profile.ProfileAuthenticationOption authenticationOption, string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override System.Web.Profile.ProfileInfoCollection GetAllInactiveProfiles(System.Web.Profile.ProfileAuthenticationOption authenticationOption, DateTime userInactiveSinceDate, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override System.Web.Profile.ProfileInfoCollection GetAllProfiles(System.Web.Profile.ProfileAuthenticationOption authenticationOption, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override int GetNumberOfInactiveProfiles(System.Web.Profile.ProfileAuthenticationOption authenticationOption, DateTime userInactiveSinceDate)
        {
            throw new NotImplementedException();
        }

        public override string ApplicationName
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

       
    }
}
