﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace MyWebSite
{
    public class UserLoader
    {
        private const string SessionKey = "User";
        
        /// <summary>
        /// Ritorna la classe User dell'utente loggato
        /// </summary>
        public static Business.User GetUserObject(string username)
        {
            
            HttpContext context = HttpContext.Current;

            //Abilitato caricamento dati dalla session
            if (Config.UserDataInSession && context.Session != null)
            {               
                if (context.Session[SessionKey] == null)
                {
                    //Aggiunge i dati in session
                    context.Session.Add(SessionKey, Business.User.GetUser(username));
                }

                return context.Session[SessionKey] as Business.User;
            }
            else
            {
                //Carica i dati da db
                return Business.User.GetUser(username);             
            }
        }

        /// <summary>
        /// Cancella i dati dell'utente dalla memoria
        /// </summary>
        public static void ClearCache()
        {
            HttpContext context = HttpContext.Current;

            if (context.Session != null && context.Session[SessionKey] != null)
            {
                context.Session[SessionKey] = null;
            }
        }

    }
}
